//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

namespace Tecan.Sila2.Interop.Client.AnyTypeTest
{
    
    
    /// <summary>
    /// Response type for the Set Any Type Value command
    /// </summary>
    [Tecan.Sila2.SilaDisplayNameAttribute("Set Any Type Value - Response")]
    public struct SetAnyTypeValueResponse
    {
        
        private string _receivedAnyType;
        
        private Tecan.Sila2.DynamicClient.DynamicObjectProperty _receivedValue;
        
        /// <summary>
        /// Initializes a new instance
        /// </summary>
        public SetAnyTypeValueResponse(string receivedAnyType, Tecan.Sila2.DynamicClient.DynamicObjectProperty receivedValue)
        {
            _receivedAnyType = receivedAnyType;
            _receivedValue = receivedValue;
        }
        
        /// <summary>
        /// The type that has been received.
        /// </summary>
        [Tecan.Sila2.SchemaAttribute("https://gitlab.com/SiLA2/sila_base/-/raw/beb5d703ab62b1242695f3a591f04a07ebc7b528" +
            "/schema/AnyTypeDataType.xsd", Tecan.Sila2.SchemaType.Xml)]
        public string ReceivedAnyType
        {
            get
            {
                return _receivedAnyType;
            }
        }
        
        /// <summary>
        /// The value that has been received.
        /// </summary>
        public Tecan.Sila2.DynamicClient.DynamicObjectProperty ReceivedValue
        {
            get
            {
                return _receivedValue;
            }
        }
    }
    
    /// <summary>
    /// Provides commands and properties to set or respectively get SiLA Any Type values via command parameters or property responses respectively.
    /// </summary>
    [Tecan.Sila2.SilaFeatureAttribute(true, "test")]
    [Tecan.Sila2.SilaIdentifierAttribute("AnyTypeTest")]
    [Tecan.Sila2.SilaDisplayNameAttribute("Any Type Test")]
    public partial interface IAnyTypeTest
    {
        
        /// <summary>
        /// Returns the Any type String value 'SiLA_Any_type_of_String_type'.
        /// </summary>
        Tecan.Sila2.DynamicClient.DynamicObjectProperty AnyTypeStringValue
        {
            get;
        }
        
        /// <summary>
        /// Returns the Any type Integer value 5124.
        /// </summary>
        Tecan.Sila2.DynamicClient.DynamicObjectProperty AnyTypeIntegerValue
        {
            get;
        }
        
        /// <summary>
        /// Returns an Any type Real value 3.1415926.
        /// </summary>
        Tecan.Sila2.DynamicClient.DynamicObjectProperty AnyTypeRealValue
        {
            get;
        }
        
        /// <summary>
        /// Returns the Any type Boolean value true.
        /// </summary>
        Tecan.Sila2.DynamicClient.DynamicObjectProperty AnyTypeBooleanValue
        {
            get;
        }
        
        /// <summary>
        /// Returns the Any type ASCII-encoded string value 'SiLA_Any_type_of_Binary_type' as Binary.
        /// </summary>
        Tecan.Sila2.DynamicClient.DynamicObjectProperty AnyTypeBinaryValue
        {
            get;
        }
        
        /// <summary>
        /// Returns the Any type Date value 05.08.2022 respective 08/05/2022, timezone +2.
        /// </summary>
        Tecan.Sila2.DynamicClient.DynamicObjectProperty AnyTypeDateValue
        {
            get;
        }
        
        /// <summary>
        /// Returns the Any type Time value 12:34:56, timezone +2.
        /// </summary>
        Tecan.Sila2.DynamicClient.DynamicObjectProperty AnyTypeTimeValue
        {
            get;
        }
        
        /// <summary>
        /// Returns the Any type Timestamp value 2022-08-05 12:34:56, timezone +2.
        /// </summary>
        Tecan.Sila2.DynamicClient.DynamicObjectProperty AnyTypeTimestampValue
        {
            get;
        }
        
        /// <summary>
        /// Returns the Any type String List value ('SiLA 2', 'Any', 'Type', 'String', 'List')
        /// </summary>
        Tecan.Sila2.DynamicClient.DynamicObjectProperty AnyTypeListValue
        {
            get;
        }
        
        /// <summary>
        /// Returns the following Any type Structure value:
        /// - String 'StringTypeValue' = 'A String value',
        /// - Integer 'IntegerTypeValue' = 83737665,
        /// - Date 'DateTypeValue' = 05.08.2022 respective 08/05/2022 timezone +2 )
        /// </summary>
        Tecan.Sila2.DynamicClient.DynamicObjectProperty AnyTypeStructureValue
        {
            get;
        }
        
        /// <summary>
        /// Receives an Any type value and returns the type and the value that has been received.
        /// </summary>
        /// <param name="anyTypeValue">The Any type value to be set.</param>
        /// <returns>The type that has been received., The value that has been received.</returns>
        [return: Tecan.Sila2.InlineStructAttribute()]
        SetAnyTypeValueResponse SetAnyTypeValue(Tecan.Sila2.DynamicClient.DynamicObjectProperty anyTypeValue);
    }
}
